<?
// $Id: obj_class.php,v 1.3 2009/09/23 14:39:04 calicant Exp $

define ('OBJLIBRARY_TABLE', 'objlibrary');

class obj_class {


    /**
     * id dell'oggetto
     *
     * idobj
     *
     * @var integer
     * @access  public
     *
     */
    var $idobj;
 

    /**
     * nome del modulo cui appartiene l'oggetto
     *
     *
     * @var string
     * @access  public
     *
     */
    var $module;
 
    /**
     * configurazione dell'oggetto
     *
     *
     * @var array
     * @access  public
     *
     */
    var $config;

    /**
     * tipo dell'oggetto
     *
     *
     * @var string
     * @access  public
     *
     */
    var $objtype;


    function obj_class($idobj, $module, $config = array()) {

        if (!$idobj || !$module)
            return false;

        if (isset($config['id']))
            unset($config['id']);

        $this->idobj = $idobj;
        $this->module = $module;
        $this->objtype = $config['objtype'];

        // controlli di esistenza
        $dbquery = "SELECT * FROM ".OBJLIBRARY_TABLE." WHERE idobj='".$this->idobj."' and module ='".$this->module."' AND `objtype` = '" . $this->objtype . "' LIMIT 1";


        $rs = select($dbquery, $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));

        if (!$rs || !$rs->RecordCount())
            return false;
        else {
            // si da precendenza alle opzioni passate dall'utente al tag
            foreach ($rs->fields as $key => $val) {
                if (!$this->config[$key])
                    $this->config[$key] = $val;
            }

            // in ogni caso ci interessa il real id (non quello di imagine o attach)
            $this->config["realid"] = $rs->fields('id');
        }

        static $xmlid = 0;
        $this->config['xmlid'] = $xmlid++;

        return true;
    }

    function getconfig() {
        $rs = select("SELECT * FROM ".OBJLIBRARY_TABLE." WHERE idobj='".$this->idobj."' and module='".$this->module."'",
                     $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));
        foreach ($rs->fields as $key => $val) {
            if (!$this->config[$key])
                $this->config[$key] = $val;
        }
    }

    function add ($idobj) {
        
        $param["idobj"] = $idobj;
        $param["iduser"] = $this->config["iduser"];
        $param["perm"] = "1";
        $param["module"] = $this->config["module"];
        $param["name"] = $this->config["name"];
        $param["objtype"] = $this->config["objtype"];
        $param["filetype"] = $this->config["filetype"];
        $param["size"] = $this->config["size"];
        $param["mime"] = $this->config["mime"];
        $param["modified"] = $this->config["modified"];
        $param["ext"] = $this->config["ext"];
        $param["pixsize"] = $this->config["pixsize"];

        $connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');

        $res = insert(OBJLIBRARY_TABLE, $param, $connh);
        if ($res === false)
            die("Fatal error: could not add " . $param["name"] . " to " . OBJLIBRARY_TABLE);

    return $connh->Insert_ID();
    }

    function remove($idobj) {

        $res = select("DELETE FROM `" . OBJLIBRARY_TABLE . "` WHERE `id` = '" . $idobj . "' LIMIT 1", $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));

        if ($res === false)
            die("Fatal error: could not delete parent object (id = '" . $idobj . "')");

    }

    function edit($idobj, $data) {

        $data = array_map("stripslashes", $data);

        $connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');

        $rowrs = select("SELECT * FROM `" . OBJLIBRARY_TABLE . "` WHERE `id` = $idobj LIMIT 1", $connh);

        // per evitare chiavi doppie su alias vuoto
        if (trim($data['alias']) == '')
            unset($data['alias']);

        if ($rowrs === false)
            die("Fatal error: could not modify parent object (id = '" . $idobj . "') [1]");
        else {
            $dbquery = $connh->GetUpdateSql($rowrs, $data, $magicq=true);
            // echo $dbquery . "<br />\n";

            $res = select($dbquery, $connh);
            if ($res === false)
                die("Fatal error: could not modify parent object (id = '" . $idobj . "') [2]");
        }

    }

    // crea un output generale dell'oggetto (tipo un toString)
    function render() {
        return $this->name;
    }

    function addtag ($tagname) {


    }

    function removetag($tagname) {

    }

    // estrae collezioni di tipi oggetto => idoggetti che matchano il tag passato
    function getobjectsbytag($tagname) {
        $ret = array();
        $rs = select("SELECT * FROM ".OBJLIBRARY_TABLE." WHERE MATCH(tags) AGAINST('".$tagname."' IN BOOLEAN MODE)",
                     $_SESSION['PRISCILLA_SESSION']->getvalue('connh'));
        while (!$rs->EOF) {
            if (!is_array($ret[$rs->fields['objtype']]))
                $ret[$rs->fields['objtype']] = array();
            array_push($ret[$rs->fields['objtype']], $rs->fields['idobj']);
            $rs->MoveNext();
        }

        return $ret;
    }

    // dalla config costruisce la stringa degli attributi html
    function assembleattributes() {
        $attributes = '';
        $style = '';
        foreach ($this->config as $key => $val) {
            if ($val)
                switch ($key) {
                    case 'alt': case 'longdesc': case 'title': case 'height': case 'width': case 'class': case 'style':
                        $attributes .= $key."=\"".$val."\" ";
                    break;
                    case 'hspace': 
                        $style .= "margin-top:".$val.";margin-bottom:".$val.";";
                    break;
                    case 'vspace':
                        $style .= "margin-left:".$val.";margin-right:".$val.";";
                    break;
                    case 'border':
                        $style .= "border:".$val."px solid black;";
                    break;
                    case 'align':
                        $style .= "float:".$val.";";
                    break;
                }
        }

        if ($style != '')
            $attributes .= "style=\"".$style."\"";

        return $attributes;
    }

    function checkperm($iduser='') {

        $usertable = $_SESSION['PRISCILLA_SESSION']->getvalue('usertable');
        if (!$iduser)
            $iduser = $usertable['username'];

        if ($usertable['livello'] != 0) {
            if ($this->config['iduser'] == $iduser)
                return true;
            else
                return $this->config['perm'];
        }
        else
            return true;
    }
}

?>
