<?

/**
 ** tag: webservices_dibilla
 ** desc: estrae un record in maniera casuale dalla tabella datatonic_dibilla specificata
 ** opt: id_datatonic_conf id della configurazione datatatonic_conf
 ** opt: table nome della tabella da cui andare a prendere la riga
 ** opt: fields nomi dei campi da estrarre. Se più di uno separare con ;
 ** opt: where clausola where opzionale per l'estrazione dei record
 ** opt: format formato di stampa dei campi estratti. ogni %s corrisponde ad un campo specificato nel parametro fields seguendo lo stesso ordine. il numero delle stringhe di formattazione deve essere uguale al numero di campi richiesti. In caso contrario viene ritornata la formattazione standard che divide ogni campo con uno spazio bianco. Per maggiori informazioni sui caratteri di formattazione consultare la pagina http://www.php.net/manual/en/function.sprintf.php
 ** eg: {webservices_dibilla id_datatonic_conf="1" table="dibilla_dinosauri" fields="nome;nome_scientifico;descrizione" format="%s, [%s] - %s"}
 ** eg: in questo esempio verrà estratta dalla tabella dinosauri la frase: nome, [nome_scientifico] - descrizione
 **/
function webservices_dibilla ($connh, $row, &$PRISCILLA_SESSION, $options)
{
    if (!trim($options['id_datatonic_conf']) || !trim($options['table']) || !trim($options['fields']))
        return '';

    $rs = $connh->Execute("SELECT * FROM datatonic_conf WHERE id='".$options['id_datatonic_conf']."'");
    if (!$rs->RecordCount())
        return '';
    $datatonic_conf = $rs->fields;

    require_once "adm/lib/nusoap.php";

    $serverpath = $datatonic_conf['serverpath'];

    $client = new soapclient0($serverpath);
    if ($fault = $client->getError())
        $ret = "<span>ERROR DT CLIENT: <strong>".$fault."</strong></span>";

    $param = array();
    $param['datatonic_username'] = $datatonic_conf['username'];
    $param['datatonic_password'] = $datatonic_conf['password'];

    $param['table'] = $options['table'];
    $fields = explode(';', $options['fields']);
    $param['fields'] = serialize($fields);
    $param['where'] = $options['where'];

    $ret = $client->call("random_row", $param);
    if ($fault = $client->getError())
        $ret = "<span>ERROR CALLING DT FUNCTION: <strong>".$fault."</strong></span>";
    else {
        $ret = unserialize($ret);
        $strret = '';
        if ($options['format'] && substr_count($options['format'], '%s') == count($ret))
            $strret = vsprintf($options['format'], $ret);
        else {
            foreach ($ret as $f => $v)
                $strret .= $v.' ';
        }
    }

    unset($client);

    return $strret;
}

?>